#if UNITY_ANROID
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Notification.Core;
using Unity.Notifications.Android;

namespace Notification.Android
{
    public class AndroidNotificationAdapter : INotification
	{
        public AndroidNotificationAdapter()
        {
			var group = new AndroidNotificationChannelGroup()
			{
				Id = "Main",
				Name = "Main notifications",
			};
			AndroidNotificationCenter.RegisterNotificationChannelGroup(group);

			var channel = new AndroidNotificationChannel()
			{
				Id = "channel_id",
				Name = "Default Channel",
				Importance = Importance.Default,
				Description = "Generic notifications",
				Group = "Main",
			};
			AndroidNotificationCenter.RegisterNotificationChannel(channel);
		}

		public void CreateNotification(string title, string message, double afterHours)
		{
			var notification = new AndroidNotification();
			notification.Title = title;
			notification.Text = message;
			notification.FireTime = System.DateTime.Now.AddHours(afterHours);

			AndroidNotificationCenter.SendNotification(notification, "channel_id");
		}
	}
}
#endif
