using Notification.Core;
using UnityEngine;

#if UNITY_ANDROID
using Notification.Android;
#elif UNITY_IOS
using Notification.iOS;
#endif

namespace Notification.Main
{
	public class NotificationFacade
    {
		private static NotificationFacade _instance;

		private INotification _notification;

		private NotificationFacade()
		{
#if UNITY_ANDROID
			_notification = new AndroidNotificationAdapter();
#elif UNITY_IOS
			var go = new GameObject();
			go.name = "iOsNotification";
			GameObject.DontDestroyOnLoad(go);

			_notification = go.AddComponent<iOSNotificationAdapter>();
#else
			_notification = new NullNotification();
#endif
		}

		public static void CreateNotification(string title, string message, double afterHours)
		{
			if (_instance == null)
			{
				_instance = new NotificationFacade();
			}

			_instance._notification.CreateNotification(title, message, afterHours);
		}
	}
}
