using System.Collections;
using Unity.Notifications.iOS;
using Notification.Core;
using UnityEngine;
using System;

namespace Notification.iOS
{
	public class iOSNotificationAdapter : MonoBehaviour, INotification
    {
		private void Start()
		{
			StartCoroutine(RequestAuthorization());
		}

		IEnumerator RequestAuthorization()
		{
			var authorizationOption = AuthorizationOption.Alert | AuthorizationOption.Badge;
			using (var req = new AuthorizationRequest(authorizationOption, true))
			{
				while (!req.IsFinished)
				{
					yield return null;
				};

				string res = "\n RequestAuthorization:";
				res += "\n finished: " + req.IsFinished;
				res += "\n granted :  " + req.Granted;
				res += "\n error:  " + req.Error;
				res += "\n deviceToken:  " + req.DeviceToken;
				Debug.Log(res);
			}
		}

		public void CreateNotification(string title, string message, double afterHours)
		{
			var hours = (int)afterHours;
			afterHours -= hours;
			afterHours *= 60;
			var minutes = (int)afterHours;
			afterHours -= minutes;
			afterHours *= 60;
			var seconds = (int)afterHours;

			var timeTrigger = new iOSNotificationTimeIntervalTrigger()
			{
				TimeInterval = new TimeSpan(hours, minutes, seconds),
				Repeats = false
			};

			var notification = new iOSNotification()
			{
				Title = title,
				Body = message,
				Subtitle = title,
				ShowInForeground = true,
				ForegroundPresentationOption = (PresentationOption.Alert | PresentationOption.Sound),
				CategoryIdentifier = "category_a",
				ThreadIdentifier = "thread1",
				Trigger = timeTrigger,
			};

			iOSNotificationCenter.ScheduleNotification(notification);
		}
	}
}
