using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace FactoryExample
{
	[RequireComponent(typeof(Renderer))]
    public class BulletBehaviour : MonoBehaviour
    {
        [SerializeField]
        private Vector3 _moveVector = Vector3.up;

		private Renderer _renderer;

		private BulletsObjectsPoolProxy _bulletsObjectsPool;
		public BulletsObjectsPoolProxy BulletsObjectsPool
		{
			set
			{
				_bulletsObjectsPool = value;
			}
		}

		public void SetMoveVector(Vector3 vector)
		{
			_moveVector = vector;
		}

		private void Start()
		{
			_renderer = GetComponent<Renderer>();
		}

		private void Update()
		{
			transform.position = transform.position + _moveVector * Time.deltaTime;

			if (!_renderer.isVisible)
			{
				if (_bulletsObjectsPool)
				{
					_bulletsObjectsPool.AddToPool(this);
				}
				else
				{
					Destroy(gameObject);
				}
				return;
			}
		}
	}
}
