using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace FactoryExample
{
    public class RedBulletFactory : BulletFactory, IFactory<BulletBehaviour>
	{
		public BulletBehaviour BulletPrefab;

		[SerializeField]
		Sprite _sprite;

		public override BulletBehaviour Create()
		{
			var bullet = Instantiate(BulletPrefab, transform);

			var render = bullet.GetComponent<SpriteRenderer>();
			render.sprite = _sprite;

			bullet.transform.localRotation = Quaternion.Euler(0, 0, 180);
			bullet.SetMoveVector(Vector3.down);

			return bullet;
		}
	}
}
