using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace FactoryExample
{
    public class SpaceShipBehaviour : MonoBehaviour
    {
        [SerializeField]
        private Transform _spawnBulletAnchor;

        [SerializeField]
		private BulletFactory _factory;

        public BulletFactory Factory
        {
            set { _factory = value; }
        }

        private void Start ()
        {
            if (_factory == null)
            {
                _factory = FindObjectOfType<BulletFactory>();
            }
        }

		private void Update()
		{
			if (Input.GetMouseButtonDown(0))
            {
                var clone = _factory.Create();

                clone.transform.position = _spawnBulletAnchor.position;
            }
		}
	}
}
