using System.Collections;
using System.Collections.Generic;
using TMPro;
using UnityEngine;
using UnityEngine.UI;

public class UIPart1 : MonoBehaviour
{
	[SerializeField]
	private TMP_InputField _input;

	[SerializeField]
	private Toggle _registerEmptySignal2Toggle;

	[SerializeField]
	private Toggle _registerStringSignal2Toggle;

	[SerializeField]
	private Button _sendEmptySignal1Button;

	[SerializeField]
	private Button _sendStringSignal1Button;


	private void Start()
	{
		var emptySignal1 = new EmptySignal1();
		var emptySignal2 = new EmptySignal2();
		var strSignal1 = new StringSignal1();
		var strSignal2 = new StringSignal2();

		_sendEmptySignal1Button.onClick.AddListener(() =>
		{
			emptySignal1.Dispatch();
		});

		_sendStringSignal1Button.onClick.AddListener(() =>
		{
			strSignal1.Dispatch(_input.text);
		});

		_registerEmptySignal2Toggle.onValueChanged.AddListener((isOn) =>
		{
			if (isOn)
			{
				emptySignal2.AddListener(OnEmptySignal2);
			}
			else
			{
				emptySignal2.RemoveListener(OnEmptySignal2);
			}
		});

		_registerStringSignal2Toggle.onValueChanged.AddListener((isOn) =>
		{
			if (isOn)
			{
				strSignal2.AddListener(OnStringSignal2);
			}
			else
			{
				strSignal2.RemoveListener(OnStringSignal2);
			}
		});
	}

	private void OnEmptySignal2()
	{
		Debug.Log("UIPart1 get empty signal");
	}

	private void OnStringSignal2(string str)
	{
		Debug.Log("UIPart1 get message:\n" + str);
	}
}
