using System.Collections;
using System.Collections.Generic;
using TMPro;
using UnityEngine;
using UnityEngine.UI;

public class UIPart2 : MonoBehaviour
{
	[SerializeField]
	private TMP_InputField _input;

	[SerializeField]
	private Toggle _registerEmptySignal1Toggle;

	[SerializeField]
	private Toggle _registerStringSignal1Toggle;

	[SerializeField]
	private Button _sendEmptySignal2Button;

	[SerializeField]
	private Button _sendStringSignal2Button;

	private void Start()
	{
		var emptySignal1 = new EmptySignal1();
		var emptySignal2 = new EmptySignal2();
		var strSignal1 = new StringSignal1();
		var strSignal2 = new StringSignal2();

		_sendEmptySignal2Button.onClick.AddListener(() =>
		{
			emptySignal2.Dispatch();
		});

		_sendStringSignal2Button.onClick.AddListener(() =>
		{
			strSignal2.Dispatch(_input.text);
		});

		_registerEmptySignal1Toggle.onValueChanged.AddListener((isOn) =>
		{
			if (isOn)
			{
				emptySignal1.AddListener(OnEmptySignal1);
			}
			else
			{
				emptySignal1.RemoveListener(OnEmptySignal1);
			}
		});

		_registerStringSignal1Toggle.onValueChanged.AddListener((isOn) =>
		{
			if (isOn)
			{
				strSignal1.AddListener(OnStringSignal1);
			}
			else
			{
				strSignal1.RemoveListener(OnStringSignal1);
			}
		});
	}

	private void OnEmptySignal1()
	{
		Debug.Log("UIPart2 get empty signal");
	}

	private void OnStringSignal1(string str)
	{
		Debug.Log("UIPart2 get message:\n" + str);
	}
}
